// autodaemon.h -- lightweight library for daemon processes

// return codes
#define AD_SUCCESS	0
#define AD_NOSOCKET	-1
#define AD_NOCONNECT	-2
#define AD_NOLISTEN	-3
#define AD_NOBIND	-4
#define AD_NOACCEPT	-5
#define AD_NOFORK	-6
#define AD_NOSETSID	-7

// flags -- only one so far
#define AD_FLAG_NONE		0
#define AD_FLAG_NODEMONIZE	1

int client(char *addr, int port,
	   int (*hook)(int (*read)(char *, int), int (*write)(char *, int), void *),
	   void *passin);

int server(int port,
	   int (*hook)(int (*read)(char *, int), int (*write)(char *, int), void *),
	   void *passin);

int daemonize(void);

int autodaemon(int port,
	       int (*clie)(int (*read)(char *,int), int (*write)(char *,int), void *),
	       int (*serv)(int (*read)(char *,int), int (*write)(char *,int), void *),
	       void *passin);

// End
